> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Migrate settings from source tenant to target tenant

POST https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy
Content-Type: application/json

To migrate the selected configuration of a tenant in Deployment Manager migration while using template from the compare screen.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/deployment-manager/configuration-templates/post-migrate-tenant-settings

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `tenant` (string, required) — Customers need to specify tenant ID in query parameter.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

### Body (application/json)

This endpoint expects a TemplateMigrationClientRequest.

- `description` (string, required) — Description of the migration.
- `entityUuid` (string, required) — Entity UUID
- `name` (string, required) — Name of the migration.
- `sendEmail` (boolean, required) — Flag determines whether or not to send an email.
- `comments` (string, optional)
- `emailIds` (string, optional) — List of Emails with comma separator.
- `metaData` (JsonNode, optional) — Json node object contains metadata.
- `request` (list of MigrationComponentContent, optional) — List of settings need to be migrated.

## Response

### 200

Successfully migrated from source to target.

- `id` (string, required) — Variable to hold the job ID.
- `migratedBy` (string, required) — User responsible for migration.
- `migrationDescription` (string, required) — Description of the migration.
- `migrationEnd` (string, required) — Timestamp when migration ended.
- `migrationName` (string, required) — Name of the migration.
- `migrationStart` (string, required) — Timestamp when migration started.
- `sourceTenantDescription` (string, required) — Source Tenant Description.
- `sourceTenantName` (string, required) — Source Tenant Name.
- `status` (string, required) — Status of the Migration Job.
- `emailIds` (string, optional) — List of Emails with comma separator
- `environment` (string, optional) — Environment information
- `response` (list of MigrationComponentContent, optional)
- `type` (string, optional)

### 201

created. The request has been fulfilled and resulted in a new resource being created. The newly created resource can be referenced by the URL(s) returned in the entity of the response, with the most specific URL for the resource given by a Location header field.

## Errors

### 400 Bad Request Error

Bad request

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

### 401 Unauthorized Error

Unauthorized

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

### 403 Forbidden Error

Forbidden

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

### 404 Not Found Error

Not Found

- `reasons` (list of ConfigTemplateErrorResponseReasonsItems, optional)

## Types

### JsonNode

Json node object contains metadata.

### MigrationComponentContent

When a comparison is made between a source and target tenant, it sends a response to the user interface.

- `attribute` (string, optional)
- `componentType` (string, optional) — Type of selected components to be migrated.
- `currentTargetResponse` (JsonNode, optional) — Json node object contains metadata.
- `description` (string, optional)
- `disabled` (string, optional)
- `errorMessage` (string, optional) — Error information.
- `httpMethods` (string, optional)
- `id` (string, optional)
- `key` (string, optional)
- `migratedOn` (datetime, optional) — It is the time when migration is triggered.
- `migrationId` (string, optional) — Migration ID. It is generated at the time of triggering deployment.
- `pathPattern` (string, optional) — PathPattern of component.
- `previousTargetResponse` (JsonNode, optional) — Json node object contains metadata.
- `result` (string, optional) — Returns the result details of Components.
- `segregationKey` (string, optional) — Displays the differences between components.
- `sourceResponse` (JsonNode, optional) — Json node object contains metadata.
- `status` (string, optional) — Returns the status of each component.
- `updateStatus` (string, optional) — Updated Status.

### ConfigTemplateErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — A detailed description of the error response.

## Examples

### response

**Request**

```json
{
  "description": "Migration from/to Sandbox",
  "entityUuid": "11111",
  "name": "Job A",
  "sendEmail": true
}
```

**Response**

```json
{
  "id": "aa7b4ffa-f30c-4f42-b240-9534f634e14f",
  "migratedBy": "Daco user",
  "migrationDescription": "Migration from/to Sandbox",
  "migrationEnd": "2020-11-01 18:00:00",
  "migrationName": "Job A",
  "migrationStart": "2020-11-01 18:00:00",
  "sourceTenantDescription": "Jren-Stage",
  "sourceTenantName": "Payment Gateway Test Tenant",
  "status": "DONE",
  "emailIds": "daco@zuora.com",
  "environment": "US-API-Sandbox-Staging",
  "response": [],
  "type": "Tenant"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy"

querystring = {"tenant":"tenant"}

payload = {
    "description": "Migration from/to Sandbox",
    "entityUuid": "11111",
    "name": "Job A",
    "sendEmail": True
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"description":"Migration from/to Sandbox","entityUuid":"11111","name":"Job A","sendEmail":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant"

	payload := strings.NewReader("{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant', [
  'body' => '{
  "description": "Migration from/to Sandbox",
  "entityUuid": "11111",
  "name": "Job A",
  "sendEmail": true
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "description": "Migration from/to Sandbox",
  "entityUuid": "11111",
  "name": "Job A",
  "sendEmail": true
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Example 2

**Request**

```json
{
  "description": "Migration from/to Sandbox",
  "entityUuid": "11111",
  "name": "Job A",
  "sendEmail": true
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy"

querystring = {"tenant":"tenant"}

payload = {
    "description": "Migration from/to Sandbox",
    "entityUuid": "11111",
    "name": "Job A",
    "sendEmail": True
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"description":"Migration from/to Sandbox","entityUuid":"11111","name":"Job A","sendEmail":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant"

	payload := strings.NewReader("{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant', [
  'body' => '{
  "description": "Migration from/to Sandbox",
  "entityUuid": "11111",
  "name": "Job A",
  "sendEmail": true
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"description\": \"Migration from/to Sandbox\",\n  \"entityUuid\": \"11111\",\n  \"name\": \"Job A\",\n  \"sendEmail\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "description": "Migration from/to Sandbox",
  "entityUuid": "11111",
  "name": "Job A",
  "sendEmail": true
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/deployment-manager/deployment_artifacts/deploy?tenant=tenant")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```